function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/** @component search-input */
import React from 'react';
import PropTypes from 'prop-types';
import { Icon, Input } from "./..";

var SearchInput = function SearchInput(props) {
  var type = props.type,
      otherProps = _objectWithoutPropertiesLoose(props, ["type"]);

  return React.createElement(Input, _extends({
    className: 'cui-search-input' + ("" + (type === 'pill' ? ' cui-search-input--pill' : ''))
  }, otherProps), React.createElement(Icon, {
    className: "cui-search-input__icon",
    name: "" + (type === 'pill' ? 'search_16' : 'search_20')
  }));
};

SearchInput.propTypes = {
  /** @prop Style of search input normal or pill | 'normal' */
  type: PropTypes.oneOf(['normal', 'pill'])
};
SearchInput.defaultProps = {
  type: 'normal'
};
SearchInput.displayName = 'SearchInput';
export default SearchInput;
/**
* @component input-search
* @section default
* @react
import { SearchInput } from '@collab-ui/react';

export default class DefaultSearchInput extends React.PureComponent {
  render() {
    return (
      <SearchInput
        name='defaultSearchInput'
        htmlId='defaultSearchInput'
        inputSize='small-5'
      />
    );
  }
}

**/

/**
* @component input-search
* @section pill
* @react
import { SearchInput } from '@collab-ui/react';

export default class PillSearchInput extends React.PureComponent {
  render() {
    return (
      <SearchInput
        name='pillSearchInput'
        htmlId='pillSearchInput'
        type='pill'
        inputSize='small-5'
      />
    );
  }
}

**/