function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * @category containers
 * @component social-list
 * @variations collab-ui-react
 */
import React from 'react';
import PropTypes from 'prop-types';

var SocialList =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(SocialList, _React$Component);

  function SocialList() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = SocialList.prototype;

  _proto.render = function render() {
    var children = this.props.children;
    return React.createElement("span", {
      className: "cui-social__list"
    }, children);
  };

  return SocialList;
}(React.Component);

SocialList.propTypes = {
  /** @prop Children nodes to render inside SocialList | null */
  children: PropTypes.node
};
SocialList.defaultProps = {
  children: null
};
SocialList.displayName = 'SocialList';
export default SocialList;
/**
* @component social-list
* @section default
* @react
import {
  List,
  ListItem,
  SocialList,
} from '@collab-ui/react';

export default class SocialListDefault extends React.PureComponent {
  render() {
    return (
      <SocialList>
        <List tabType='horizontal' className='social-list'>
          <ListItem>
            <i className='icon icon-facebook-circle_40' />
          </ListItem>
          <ListItem>
            <i className='icon icon-twitter-circle_40' />
          </ListItem>
          <ListItem>
            <i className='icon icon-linkedin-circle_40' />
          </ListItem>
        </List>
      </SocialList>
    );
  }
}
**/