"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ = require("./..");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var Button =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Button, _React$Component);

  function Button() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _this.handleKeyDown = function (e) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          index = _this$props.index;
      var _this$context = _this.context,
          handleKeyDown = _this$context.handleKeyDown,
          handleClick = _this$context.handleClick;

      if (e.which === 32 || e.which === 13 || e.charCode === 32 || e.charCode === 13) {
        handleClick && handleClick(e, index);
        onClick && onClick(e);
        e.preventDefault();
      } else {
        handleKeyDown && handleKeyDown(e, index);
      }
    };

    _this.handleClick = function (e, onClick) {
      var handleClick = _this.context.handleClick;
      var index = _this.props.index;
      onClick && onClick(e);
      handleClick && handleClick(e, index);
    };

    return _this;
  }

  var _proto = Button.prototype;

  _proto.componentDidMount = function componentDidMount() {
    /* eslint-disable no-console */
    var _this$props2 = this.props,
        ariaLabel = _this$props2.ariaLabel,
        ariaLabelledBy = _this$props2.ariaLabelledBy,
        index = _this$props2.index;
    var _this$context2 = this.context,
        focusIndex = _this$context2.focusIndex,
        focusOnLoad = _this$context2.focusOnLoad;
    !ariaLabel && !ariaLabelledBy && console.warn('[@collab-ui/react] Button: Accessibility could be improved with ariaLabel');
    focusOnLoad && focusIndex === index && this.refs.button.focus();
    /* eslint-enable no-console */
  };

  _proto.componentWillUpdate = function componentWillUpdate() {
    this.prevContext = this.context;
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    var focusIndex = this.context.focusIndex;
    var index = this.props.index;
    typeof index === 'number' && index === focusIndex && focusIndex !== this.prevContext.focusIndex && this.refs.button.focus();
  };

  _proto.render = function render() {
    var _this2 = this;

    var _this$props3 = this.props,
        active = _this$props3.active,
        ariaLabel = _this$props3.ariaLabel,
        ariaLabelledBy = _this$props3.ariaLabelledBy,
        children = _this$props3.children,
        circle = _this$props3.circle,
        className = _this$props3.className,
        color = _this$props3.color,
        containerLarge = _this$props3.containerLarge,
        disabled = _this$props3.disabled,
        expand = _this$props3.expand,
        href = _this$props3.href,
        index = _this$props3.index,
        isButtonGroup = _this$props3.isButtonGroup,
        label = _this$props3.label,
        loading = _this$props3.loading,
        large = _this$props3.large,
        _onClick = _this$props3.onClick,
        removeStyle = _this$props3.removeStyle,
        size = _this$props3.size,
        style = _this$props3.style,
        tag = _this$props3.tag,
        type = _this$props3.type,
        otherHTMLProps = _objectWithoutPropertiesLoose(_this$props3, ["active", "ariaLabel", "ariaLabelledBy", "children", "circle", "className", "color", "containerLarge", "disabled", "expand", "href", "index", "isButtonGroup", "label", "loading", "large", "onClick", "removeStyle", "size", "style", "tag", "type"]);

    var focusIndex = this.context.focusIndex;

    var isButtonGroupIcon = function isButtonGroupIcon() {
      return isButtonGroup && children && _react.default.Children.toArray(children).reduce(function (prev, child) {
        return prev ? prev : child.type && child.type.displayName === 'Icon';
      }, false);
    };

    var getChildren = function getChildren() {
      return [loading && _react.default.createElement("div", {
        key: "child-0"
      }, _react.default.createElement(_.Loading, null)), _react.default.createElement("span", {
        className: "cui-button__children",
        style: {
          opacity: "" + (loading ? 0 : 1)
        },
        key: "child-1"
      }, children)];
    };

    var getColor = function getColor() {
      if (removeStyle) return false;
      return color === 'none' ? 'color-none' : color;
    }; // Method for deprecated large prop


    var getSize = function getSize() {
      if (removeStyle) return false;
      /* eslint-disable no-console */

      var validButtonSize = checkButtonSize();

      if (!circle && !validButtonSize) {
        console.warn('[@collab-ui/react] Button: selected size is not supported for non-circular button. Size will default to 36');
        return '36';
      } else if (large) {
        console.warn('[@collab-ui/react] Button: large prop is deprecated and will be removed. Please use size prop.');
        return !circle ? '52' : '44';
      } else {
        return size === 'none' ? 'size-none' : size;
      }
      /* eslint-enable no-console */

    };

    var checkButtonSize = function checkButtonSize() {
      return ['none', '28', '36', '40', '52', 28, 36, 40, 52].includes(size);
    };

    var button = _react.default.createElement(tag, _extends({
      ref: 'button',
      className: 'cui-button' + ("" + (circle && " cui-button--circle" || '')) + ("" + (isButtonGroupIcon() && " cui-button--icon-group" || '')) + ("" + (getSize() && " cui-button--" + getSize() || '')) + ("" + (expand && " cui-button--expand" || '')) + ("" + (color && " cui-button--" + getColor() || '')) + ("" + (removeStyle && ' cui-button--none' || '')) + ("" + (active && !disabled && " active" || '')) + ("" + (className && " " + className || '')),
      onClick: function onClick(e) {
        return _this2.handleClick(e, _onClick);
      },
      onKeyDown: this.handleKeyDown,
      style: style,
      disabled: disabled || loading,
      alt: ariaLabel || label,
      href: tag === 'a' && href || undefined,
      type: tag !== 'a' && type || ''
    }, ariaLabel ? {
      'aria-label': ariaLabel
    } : {
      'aria-labelledby': ariaLabelledBy
    }, {
      tabIndex: typeof index !== 'number' || index === focusIndex ? 0 : -1
    }, tag && tag !== 'button' && {
      role: 'button'
    }, otherHTMLProps), getChildren());

    return label ? _react.default.createElement("div", {
      className: "cui-button__container" + (containerLarge ? '' : '--small')
    }, button, _react.default.createElement("div", {
      className: "cui-button__label"
    }, label)) : button;
  };

  return Button;
}(_react.default.Component);

Button.displayName = 'Button';
Button.contextTypes = {
  focusIndex: _propTypes.default.number,
  focusOnLoad: _propTypes.default.bool,
  handleClick: _propTypes.default.func,
  handleKeyDown: _propTypes.default.func
};
Button.propTypes = {
  /** @prop Sets active css styling | false */
  active: _propTypes.default.bool,

  /** @prop Text to display for blindness accessibility features | '' */
  ariaLabel: _propTypes.default.string,

  /** @prop ID to reference for blindness accessibility feature | '' */
  ariaLabelledBy: _propTypes.default.string,

  /** @prop Children Nodes to Render inside Button | null */
  children: _propTypes.default.node.isRequired,

  /** @prop Sets circle css styling | false */
  circle: _propTypes.default.bool,

  /** @prop Optional css class string | '' */
  className: _propTypes.default.string,

  /** @prop Sets optional Button color | '' */
  color: _propTypes.default.string,

  /** @prop Sets containerLarge css styling | false */
  containerLarge: _propTypes.default.bool,

  /** @prop Sets the attribute disabled to Button | false */
  disabled: _propTypes.default.bool,

  /** @prop Sets expand css styling to widen the Button | false */
  expand: _propTypes.default.bool,

  /** @prop Href prop changes element to anchor element | '' */
  href: _propTypes.default.string,

  /** @prop This index is used to control focus of Button within a ButtonGroup | null */
  index: _propTypes.default.number,

  /** @prop Determines whether class should be applied to ButtonGroups with Icons as descendants | false */
  isButtonGroup: _propTypes.default.bool,

  /** @prop Text to display inside the button | '' */
  label: _propTypes.default.string,

  /** @prop Depreciated large css styling, use size instead | false */
  large: _propTypes.default.bool,

  /** @prop Activates the loading animation and sets the button to disabled | false */
  loading: _propTypes.default.bool,

  /** @prop Handler to be called when the user taps the button | null */
  onClick: _propTypes.default.func,

  /** @prop Optional prop to remove Button's default style | false */
  removeStyle: _propTypes.default.bool,

  /** @prop Optional string or number size prop | 36 */
  size: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),

  /** @prop Additional css styling applied to the button | {} */
  style: _propTypes.default.object,

  /** @prop Optional tag to define type of element | 'button' */
  tag: _propTypes.default.oneOf(['button', 'input', 'a']),

  /** @prop Optional html type | 'button' */
  type: _propTypes.default.oneOf(['button', 'reset', 'submit'])
};
Button.defaultProps = {
  active: false,
  ariaLabel: '',
  ariaLabelledBy: '',
  children: null,
  circle: false,
  className: '',
  color: '',
  containerLarge: false,
  disabled: false,
  expand: false,
  href: '',
  index: null,
  isButtonGroup: false,
  label: '',
  large: false,
  loading: false,
  onClick: null,
  removeStyle: false,
  size: 36,
  style: {},
  tag: 'button',
  type: 'button'
};
var _default = Button;
/**
* @component button
* @section default
* @react
import { Button } from '@collab-ui/react';

export default function ButtonDefault() {
  return(
    <Button
      children='Test Me'
      ariaLabel='For the Win'
    />
  );
}
**/

/**
* @component button
* @section tags
* @react
import { Button } from '@collab-ui/react';

export default function ButtonTags() {
  return(
    <Button
      children='Link'
      onClick={() => { }}
      ariaLabel='For the Win'
      tag='a'
    />
  );
}
**/

/**
* @component button
* @section color
* @react
import { Button } from '@collab-ui/react';

export default function ButtonColor() {
  return(
    <Button
      children='Test Me'
      onClick={() => { }}
      ariaLabel='For the Win'
      color='blue'
    />
  );
}
**/

/**
* @component button
* @section size
* @react
import { Button } from '@collab-ui/react';

export default function ButtonSize() {
  return(
    <div className="example-spacing">
      <div>
        <Button
          ariaLabel='For the Win'
          size='none'
        >
          no size
        </Button>
      </div>
      <br />
      <div>
        <Button
          ariaLabel='For the Win'
          size={28}
        >
          size 28
        </Button>
      </div>
      <br />
      <div>
        <Button
          ariaLabel='For the Win'
        >
          size 36
        </Button>
      </div>
      <br />
      <div>
        <Button
          ariaLabel='For the Win'
          size={40}
        >
          size 40
        </Button>
      </div>
      <br />
      <div>
        <Button
          ariaLabel='For the Win'
          size={52}
        >
          size 52
        </Button>
      </div>
      <br />
    </div>
  );
}
**/

/**
* @component button
* @section circle
* @react
import { Button } from '@collab-ui/react';

export default function ButtonCircle() {
  return(
    <Button
      children={<Icon name='icon-search_12' />}
      onClick={() => { }}
      ariaLabel='For the Win'
      circle
    />
  );
}
**/

/**
* @component button
* @section expanded
* @react
import { Button } from '@collab-ui/react';

export default function ButtonExpand() {
  return(
    <Button
      children='Test Me'
      onClick={() => { }}
      ariaLabel='For the Win'
      expand
    />
  );
}
**/

/**
* @component button
* @section disabled
* @react
import { Button } from '@collab-ui/react';

export default function ButtonDisabled() {
  return(
    <Button
      children='Test Me'
      onClick={() => { }}
      ariaLabel='For the Win'
      disabled
    />
  );
}
**/

/**
* @component button
* @section loading
* @react
import { Button } from '@collab-ui/react';

export default function ButtonLoading() {
  return(
    <Button
      children='Test Me'
      onClick={() => {}}
      ariaLabel='For the Win'
      loading
    />
  );
}
**/

exports.default = _default;