"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @component input */
var InputHelper = function InputHelper(_ref) {
  var message = _ref.message,
      className = _ref.className;
  return _react.default.createElement("p", {
    className: "cui-input__help-text " + className
  }, message);
};

InputHelper.propTypes = {
  /** @prop Optional css class name | '' */
  className: _propTypes.default.string,

  /** @prop Input help message for parent Input | null */
  message: _propTypes.default.string.isRequired
};
InputHelper.defaultProps = {
  className: '',
  message: null
};
InputHelper.displayName = 'InputHelper';
var _default = InputHelper;
/**
* @component input
* @section Input Helper
*
* @react

import {
  Checkbox,
  InputHelper
} from '@collab-ui/react';

export default function InputHelperDefault() {
  return (
    <div className='row'>
      <Checkbox
        value='us'
        label='us'
        htmlId='inputHelper1'
        onChange={()=>{}}
      >
        <InputHelper message={'I\'m here to help'} />
      </Checkbox>
    </div>
  );
}

**/

exports.default = _default;