"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Label = function Label(_ref) {
  var className = _ref.className,
      htmlFor = _ref.htmlFor,
      label = _ref.label,
      theme = _ref.theme,
      props = _objectWithoutPropertiesLoose(_ref, ["className", "htmlFor", "label", "theme"]);

  return _react.default.createElement("label", _extends({
    className: "" + (className ? " " + className : '') + ("" + (theme ? " cui-label--" + theme : '')),
    htmlFor: htmlFor
  }, props), _react.default.createElement("span", null, label));
};

Label.propTypes = {
  /** @prop HTML class name for associated Input | '' */
  className: _propTypes.default.string,

  /** @prop HTML ID for associated Input | null */
  htmlFor: _propTypes.default.string.isRequired,

  /** @prop Required Label text | null */
  label: _propTypes.default.string.isRequired,

  /** @prop Set Label's color theme | '' */
  theme: _propTypes.default.string
};
Label.defaultProps = {
  className: '',
  htmlFor: null,
  label: null,
  theme: ''
};
Label.displayName = 'Label';
var _default = Label;
/**
* @component label
* @section default
*
* @react
import { Label } from '@collab-ui/react';

export default function LabelDefault() {
  return (
    <Label
      htmlFor='label1'
      label='Default Label'
    />
  );
}

**/

exports.default = _default;