"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @component loading-spinner */
var Loading = function Loading(props) {
  var small = props.small;
  return _react.default.createElement("div", {
    className: "cui-loading " + (small ? 'cui-loading--small' : '')
  }, _react.default.createElement("span", {
    className: "cui-loading__icon"
  }), _react.default.createElement("span", {
    className: "cui-loading__icon"
  }), _react.default.createElement("span", {
    className: "cui-loading__icon"
  }));
};

Loading.propTypes = {
  /** @prop Prop to make the Loading animation small | false */
  small: _propTypes.default.bool
};
Loading.defaultProps = {
  small: false
};
Loading.displayName = 'Loading';
var _default = Loading;
/**
* @name Default Loading
* @description Loadings are useful.
*
* @category communication
* @component loader-spinner
* @section default
*
* @js
import { Loading } from '@collab-ui/react';

export default function LoaderSpinnerDefault() {
  return (
    <div className="row">
      <div className="docs-example docs-example--spacing" style={{fontSize: '1rem', display: 'flex'}}>
        <Loading />
      </div>
      <div className="docs-example docs-example--spacing" style={{fontSize: '2rem', display: 'flex'}}>
        <Loading />
      </div>
      <div className="docs-example docs-example--spacing" style={{fontSize: '3rem', display: 'flex'}}>
        <Loading />
      </div>
    </div>
  );
}

**/

exports.default = _default;