"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ModalBody = function ModalBody(props) {
  var className = props.className,
      other = _objectWithoutPropertiesLoose(props, ["className"]);

  return _react.default.createElement("div", _extends({
    className: "cui-modal__body" + ("" + (className && " " + className || ''))
  }, other), props.children);
};

ModalBody.propTypes = {
  /** @prop Children nodes to render inside the ModalBody | null */
  children: _propTypes.default.node,

  /** @prop Optional css class names | '' */
  className: _propTypes.default.string
};
ModalBody.defaultProps = {
  children: null,
  className: ''
};
ModalBody.displayName = 'ModalBody';
var _default = ModalBody;
/**
* @name Modal Body
*
* @category containers
* @component modal
* @section modal-body
*
* @js

import {
  Input,
  ModalBody,
} from '@collab-ui/react';

export default function ModalBody() {
    return (
      <div className='row'>
        <br />
        <ModalBody>
          <Input
            htmlId='testMe2'
            value='testMe2'
            name='testMe2'
            label='First Input'
            disabled
            placeholder='Disabled Input'
            onChange={() => {}}
            inputHelpText='Field Must be Disabled'
            errorArr={[]}
          />
        </ModalBody>
      </div>
    );
  }

**/

exports.default = _default;